#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <string.h>

#define DURATA_NOTA 100

#define SING 1
#define REC 2
#define PLAY 3

/* The structure that defines a note:
 *  - index:  the oder in the vector song
 *  - delay:  the duration of the note 
 * 	- frecv:  the frequency of the note
 *  */
typedef struct {
        char index;
        unsigned int delay;
		unsigned int frecv;
} note; 

float frecv[8] = {
	261.63, 293.66, 329.63, 349.23, 392.0, 440.0, 493.88, 523.25
};

/* Current working mode */
int crt_mode;

/* The placeholder for a recorded song */
unsigned int song[100];
/* The length (int notes) of the recorded song */
int song_size;
/* Index of the current note, used for recording and playing */
int crt_note = -1;

unsigned int x;

void reda_nota(unsigned int x)
{
	float perioada = 100000 / x;
		
	for(int j = 0;j < perioada / 2;j++)
		_delay_us(1);
		
	for(int j = 0;j < perioada / 2;j++)
	{
		PORTD ^= (1 << PD5);
		_delay_ms(2);
	}
		
	for(int j = 0;j < perioada / 2;j++)
		_delay_us(1);
}
void  initBoard()
{
        /* Set the output pin for buzzer*/
        DDRD |= (1 << PD5);        
		
		DDRB &= ~((1 << PB0) | (1 << PB1) | (1 << PB2) | (1 << PB3) | (1 << PB4) | (1 << PB5) | (1 << PB6) | (1 << PB7));
		PORTB |= (1 << PB0) | (1 << PB1) | (1 << PB2) | (1 << PB3) | (1 << PB4) | (1 << PB5) | (1 << PB6) | (1 << PB7);
		
		DDRA &= ~((1 << PA0) | (1 << PA1) | (1 << PA2));
		PORTA |= (1 << PA0) | (1 << PA1) | (1 << PA2); 

        /* Initialize mode */
        crt_mode = -1;
}

int select_nota()
{
	int x = -1;
	
	if((PINB & (1 << PB0)) == 0)
		x = 0;
	if((PINB & (1 << PB1)) == 0)
		x = 1;
	if((PINB & (1 << PB2)) == 0)
		x = 2;
	if((PINB & (1 << PB3)) == 0)
		x = 3;
	if((PINB & (1 << PB4)) == 0)
		x = 4;
	if((PINB & (1 << PB5)) == 0)
		x = 5;
	if((PINB & (1 << PB6)) == 0)
		x = 6;
	if((PINB & (1 << PB7)) == 0)
		x = 7;
		
	return x;
}

int main() {
        initBoard();
		int i;
		
		x = -1;
	 
		crt_mode = -1;
	 
        while(1)
        {	
			if(crt_mode == PLAY)
			{
				DDRD |= (1 << PD7);
				PORTD |= (1 << PD7);
				for(i = 0;i < song_size;i++)
				{
					reda_nota(song[i]);
					_delay_ms(10);
				}
				
				crt_mode = SING;
				PORTD &= ~(1 << PD7);
			}
			
			if(crt_mode == SING)
			{	
				x = select_nota();
					
				if((int)x != -1)
					reda_nota(frecv[x]);
					
				_delay_ms(10);
				
				x = -1;
			}
			
			if(crt_mode == REC)
			{
				x = select_nota();
					
				if((int)x != -1)
				{
					reda_nota(frecv[x]);
					_delay_ms(10);
					
					song[crt_note] = frecv[x];
					song_size++;
					crt_note++;
				}
				
				x = -1;
			}
			
			if((PINA & (1 << PA2)) == 0)
			{
					crt_mode = SING;
			} 
			
			if((PINA & (1 << PA0)) == 0)
			{
				crt_mode = PLAY;
			}
			
			if((PINA & (1 << PA1)) == 0)
			{
				crt_mode = REC;
				crt_note = 0;
				
				for(i = 0;i < 100;i++)
				{
					song[i] = 0;
				}
			}
        }  
	 
	return 0;
}
